# TCP Junction

TCP junction is a tiny TCP-level reverse project implemented in Rust.
The binary doesn't read a configuration file and is completely configured via command-line arguments.
Upstream health is inferred from TCP connection success or failure.

TCP Junction makes it easy to implemented dynamic primary/standby setups or canary deployments.

## Junction logic

TCP Junction accepts at list of `host:port` as it's command-line arguments. The first entry
is the host and port to listen on, e.g., `0.0.0.0:8080`. All allowing arguments are considered
upstream sockets.

* By default, the first item in the list is the preferred socket and
  all requests are sent to that host.
* If the preferred socket is offline, all requests are sent to the next online socket in the list,
  cycling back to the beginning at the end of the list.
* If all sockets are offline and the search for an online socket reach the preferred server again,
  requests are sent to the preferred socket regardless of its state.
* When TCP Junction receives the `USR1` signal, the preferred host is advanced by one socket,
  cycling back at the end.

Health probes are sent continuously to all configured upstream sockets.

## Usage example

```bash
$ tcpjunction 0.0.0.0:8080 10.0.0.20:8080 10.0.0.21:8080
```
